﻿namespace EndMove.Sudoku.Solver.Core;

// PS: I know this class isn't useful at all, I just wanted to play a bit more
public class SudokuStore
{
    private readonly List<int[,]> _sudokuBoards;

    public SudokuStore()
    {
        _sudokuBoards = new List<int[,]>();
    }

    // Add multiple Sudoku boards
    public void AddBoard(params int[][,] boards)
    {
        foreach (var board in boards)
        {
            AddBoard(board);
        }
    }

    // Add a new Sudoku board
    public void AddBoard(int[,] board)
    {
        if (board.GetLength(0) != 9 || board.GetLength(1) != 9)
        {
            throw new ArgumentException("Board must be a 9x9 grid.");
        }
        _sudokuBoards.Add((int[,])board.Clone());
    }

    // Remove a Sudoku board by index
    public void RemoveBoard(int index)
    {
        if (index < 0 || index >= _sudokuBoards.Count)
        {
            throw new ArgumentOutOfRangeException(nameof(index), "Invalid board index.");
        }
        _sudokuBoards.RemoveAt(index);
    }

    // Get the count of stored Sudoku boards
    public int Count => _sudokuBoards.Count;

    // Indexer to access Sudoku boards by index
    public int[,] this[int index]
    {
        get
        {
            if (index < 0 || index >= _sudokuBoards.Count)
            {
                throw new ArgumentOutOfRangeException(nameof(index), "Invalid board index.");
            }
            return (int[,])_sudokuBoards[index].Clone();
        }
        set
        {
            if (index < 0 || index >= _sudokuBoards.Count)
            {
                throw new ArgumentOutOfRangeException(nameof(index), "Invalid board index.");
            }

            if (value.GetLength(0) != 9 || value.GetLength(1) != 9)
            {
                throw new ArgumentException("Board must be a 9x9 grid.");
            }
            _sudokuBoards[index] = (int[,])value.Clone();
        }
    }
}